<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import _ from "lodash";
import { getTimeZone } from "~/utils/timeZone";
var momentz = require("moment-timezone");
var moment = require("moment");
@Component({})
export default class AdminDiscountComponent extends Vue {
  loadingTable = false;

  config = {
    page: 1,
    limit: 25,
    search: "",
  };
  totalPage = 1;
  page = 1;

  listDiscount = [];

  get siteInfo() {
    return this.$store.state.setting.siteInfo;
  }

  mounted() {
    this.onGetListDiscount();
  }

  async onGetListDiscount() {
    try {
      this.loadingTable = true;
      const response = await this.$api.AdminDiscount.list(this.config);
      if (response?.data) {
        const { total, data } = response.data;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.listDiscount = data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  onRedirectPage() {
    this.config.page = this.page;
    this.onGetListDiscount();
  }

  redirectPageEdit(id: string) {
    this.$router.push(`/seller/discounts/edit/${id}`);
  }

  formatUnix(unix: number) {
    return momentz
      .unix(unix)
      .tz(getTimeZone(this.siteInfo.timezone))
      .format("HH:mm YYYY-MM-DD");
  }

  @Watch("config.page")
  changedPage() {
    this.onGetListDiscount();
  }
}
</script>

<style></style>
